--[[--
	ALA@163UI
	All Rights Reseverd
--]]--
local ADDON, NS = ...;
_G.__ala_meta__ = _G.__ala_meta__ or {  };
local __ns = {  };
NS.InstanceLockeddownTimer = __ns;
__ala_meta__.InstanceLockeddownTimer = __ns;

local _G = _G;
do
	if __ns.__fenv == nil then
		__ns.__fenv = setmetatable({  },
				{
					__index = _G,
					__newindex = function(t, key, value)
						rawset(t, key, value);
						print("ilt assign global", key, value);
						return value;
					end,
				}
			);
	end
	setfenv(1, __ns.__fenv);
end

-->			upvalue
	local setmetatable, tinsert, tremove, unpack, next = setmetatable, tinsert, tremove, unpack, next;
	local type, tostring = type, tostring;
	local strsplit, strsub, strfind, format = strsplit, strsub, strfind, format;
	local date = date;
-->			global variables
	local DAY_LIMIT = 30;
	local BIG_NUMBER = 4294967295;
	local ONE_HOUR = 3600;
	local ONE_DAY = 86400;
--
local SET, VAR = nil, nil;

local L = {  };
do
	if GetLocale() == 'zhCN' or GetLocale() == 'zhTW' then
		L["VARIABLES_ERROR"] = "\124cff00ff00InstanceLockeddownTimer\124r 配置文件错误";
		L["INSTANCE_CHANCE"] = "副本次数";
		L["CURRENT"] = "当前";
		L["AVAILABLE"] = "可用";
		L["AVAILABLE_GLOBAL"] = "可重置";
		L["LOCK"] = "锁定";
		L["CLOSE"] = "关闭";
		L["RESETINSTANCE"] = "重置副本";
		L["TIP_GLOBAL_HEADER"] = "\124cffffffff24小时副本次数\124r";
		L["TIP_INSTANCE"] = "\124cffffffff副本";
		L["TIP_GLOBAL_FORMAT_AVAILABLE"] = "\124cff00ff00可用: %d\124r";
		L["TIP_GLOBAL_FORMAT_LOCKED"] = "\124cffff0000锁定: %d\124r";
		L["TIP_GLOBAL_ALT"] = "按Alt显示完整细节";
		L["TIP_GLOBAL_SHIFT"] = "按Shift显示详情";

		L["RESET"] = "%s 已被重置，请重新进入副本";
	else
		L["VARIABLES_ERROR"] = "\124cff00ff00InstanceLockeddownTimer\124r VARIABLES_ERROR";
		L["INSTANCE_CHANCE"] = "Inst lock ";
		L["CURRENT"] = "CUR";
		L["AVAILABLE"] = "AVL";
		L["AVAILABLE_GLOBAL"] = "AVL";
		L["LOCK"] = "LOCK";
		L["CLOSE"] = "CLOSE";
		L["RESETINSTANCE"] = "Reset instance";
		L["TIP_GLOBAL_HEADER"] = "\124cffffffffLimit in 24hrs\124r";
		L["TIP_INSTANCE"] = "\124cffffffffInst ";
		L["TIP_GLOBAL_FORMAT_AVAILABLE"] = "\124cff00ff00AVL: %d\124r";
		L["TIP_GLOBAL_FORMAT_LOCKED"] = "\124cffff0000LOCKED: %d\124r";
		L["TIP_GLOBAL_ALT"] = "Holding Shift to show all details";
		L["TIP_GLOBAL_SHIFT"] = "Holding Shift to show info";

		L["RESET"] = "%s is reseted. Reenter the instance.";
	end
end

local function _noop_()
	return true;
end
local function __log__(...)
	-- tinsert(logfile, { date('\124cff00ff00%H:%M:%S\124r'), ... });
end
local function Info_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP");
	GameTooltip:SetText(self.info);
	GameTooltip:Show();
end
local function Info_OnLeave(self)
	if GameTooltip:IsOwned(self) then
		GameTooltip:Hide();
	end
end

local _EventHandler = CreateFrame('FRAME');
-->		--	EventHandler
	local function _EventHandler_OnEvent(self, event, ...)
		return __ns[event](...);
	end
	function _EventHandler:FireEvent(event, ...)
		local func = __ns[event];
		if func then
			return func(...);
		end
	end
	function _EventHandler:RegEvent(event)
		__ns[event] = __ns[event] or _noop_;
		self:RegisterEvent(event);
		self:SetScript('OnEvent', _EventHandler_OnEvent);
	end
	function _EventHandler:UnregEvent(event)
		self:UnregisterEvent(event);
	end
-->

-->		UTILS
	function __ns.time_to_stamp(f, t)
		return date(f, t + 57600 - 1);
	end
-->		GUI
	function __ns.initUI()
		-->	1hr limit
			--	mainUI
				local ui = CreateFrame("FRAME", nil, UIParent);
				ui:SetSize(140, 80);
				ui:SetBackdrop({
					bgFile = "Interface/ChatFrame/ChatFrameBackground",
					edgeFile = "Interface/ChatFrame/ChatFrameBackground",
					tile = true,
					edgeSize = 1,
					tileSize = 5,
				});
				ui:SetMovable(true);
				function __ns.EnableUI()
					ui:Show();
					SET.enabled = true;
				end
				function __ns.DisableUI()
					ui:Hide();
					SET.enabled = false;
				end
				function __ns.LockUI()
					ui:EnableMouse(false);
					ui:SetBackdropColor(0.0, 0.0, 0.0, 0.0);
					ui:SetBackdropBorderColor(0.0, 0.0, 0.0, 0.0);
					SET.locked = true;
				end
				function __ns.UnlockUI()
					ui:EnableMouse(true);
					ui:SetBackdropColor(0.0, 0.0, 0.0, 0.5);
					ui:SetBackdropBorderColor(0.0, 0.0, 0.0, 0.5);
					SET.locked = false;
				end

				local drop_menu_table = {
					handler = _noop_,
					elements = {
						{
							handler = __ns.LockUI,
							para = {  },
							text = L["LOCK"],
						},
						{
							handler = ui.off,
							para = {  },
							text = L["CLOSE"],
						},
					},
				};
				ui:SetScript("OnMouseDown", function(self, button)
					if button == "LeftButton" then
						self:StartMoving();
					else
						ALADROP(ui, "BOTTOMLEFT", drop_menu_table);
					end
				end);
				ui:SetScript("OnMouseUp", function(self, button)
					self:StopMovingOrSizing();
					SET.pos = { self:GetPoint(), };
					for i, v in next, SET.pos do
						if type(v) == 'table' then
							SET.pos[i] = v:GetName();
						end
					end
				end);
			--	board line
				local lines = {  };
				ui.lines = lines;
				for i = 1, 5 do
					local strL = ui:CreateFontString(nil, "OVERLAY");
					strL:SetFont(GameFontNormal:GetFont(), 16);
					strL:SetPoint("TOPLEFT", ui, "TOPLEFT", 0, - 16 * (i - 1));
					strL:SetJustifyH("CENTER");
					strL:Show();
					strL:SetText("\124cffffff00" .. L["INSTANCE_CHANCE"] .. i .. "\124r:  ");
					local strR = ui:CreateFontString(nil, "OVERLAY");
					strR:SetFont(GameFontNormal:GetFont(), 16);
					strR:SetPoint("TOP", strL, "TOP", 0, 0);
					strR:SetPoint("RIGHT", ui, "RIGHT", 0, 0);
					strR:SetJustifyH("CENTER");
					strR:Show();
					strR:SetText("\124cff00ff00" .. L["AVAILABLE"] .. "\124r");
					strR.id = i;
					local line = { strL, strR, };
					function line:SetText(...)
						strR:SetText(...);
					end
					lines[i] = line;
				end
				function __ns.LineSetText(index, ...)
					lines[index]:SetText(...);
				end
			--	reset instance
				local resetInstances = CreateFrame("BUTTON", nil, ui);
				resetInstances:SetSize(16, 16);
				resetInstances:SetNormalTexture("interface\\common\\indicator-green");
				resetInstances:SetHighlightTexture("Interface\\common\\indicator-gray");
				resetInstances:SetPoint("BOTTOMRIGHT", ui, "TOPRIGHT", 0, 0);
				resetInstances:Show();
				resetInstances:EnableMouse(true);
				-- resetInstances:RegisterForClicks("LeftButton");
				resetInstances.info = L["RESETINSTANCE"];
				resetInstances:SetScript("OnEnter", Info_OnEnter);
				resetInstances:SetScript("OnLeave", Info_OnLeave);
				resetInstances:SetScript("OnClick", function()
					ResetInstances();
				end);
				ui.resetInstances = resetInstances;
			--
		-->	24hrs limit	--	new for hotfix 20200612
			local dayLimit = CreateFrame("BUTTON", nil, ui);
			dayLimit:SetHeight(24);
			dayLimit:SetPoint("TOPLEFT", ui, "BOTTOMLEFT");
			dayLimit:SetPoint("TOPRIGHT", ui, "BOTTOMRIGHT");
			dayLimit:Show();
			ui.dayLimit = dayLimit;
			local dayLimitStr = dayLimit:CreateFontString(nil, "OVERLAY");
			dayLimitStr:SetFont(GameFontNormal:GetFont(), 16);
			dayLimitStr:SetPoint("CENTER");
			dayLimitStr:SetJustifyH("CENTER");
			dayLimitStr:Show();
			ui.dayLimitStr = dayLimitStr;
			local function dayLimitOnEnter(self)
				local list = VAR.list;
				local num = #list;
				local num24hrs = 0;
				for index = 1, num do
					local info = list[index];
					if info[4] == 'party' then
						num24hrs = num24hrs + 1;
					end
				end
				if self:GetTop() + self:GetBottom() < UIParent:GetHeight() then
					GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 96);
				else
					GameTooltip:SetOwner(self, "ANCHOR_BOTTOM");
				end
				GameTooltip:SetText(L["TIP_GLOBAL_HEADER"]);
				GameTooltip:AddDoubleLine(format(L["TIP_GLOBAL_FORMAT_AVAILABLE"], DAY_LIMIT - num24hrs),
											format(L["TIP_GLOBAL_FORMAT_LOCKED"], num24hrs));
				if num24hrs > 0 then
					if IsAltKeyDown() then
						local now = GetServerTime();
						local index = 0;
						for i = 1, num do
							local info = list[i];
							if info[4] == 'party' then
								index = index + 1;
								GameTooltip:AddDoubleLine(
										L["TIP_INSTANCE"] .. index .. " \124cffff7f00" .. GetRealZoneText(info[3]) .. "\124r uid " .. info[2],
										__ns.time_to_stamp("\124cffff0000[%H:%M:%S]\124r", info[1] - now + ONE_DAY)
									);
							end
						end
					elseif IsShiftKeyDown() then
						local now = GetServerTime();
						local index = 0;
						for i = 1, num do
							local info = list[i];
							if info[4] == 'party' then
								index = index + 1;
								GameTooltip:AddDoubleLine(
										L["TIP_INSTANCE"] .. index,
										__ns.time_to_stamp("\124cffff0000[%H:%M:%S]\124r", info[1] - now + ONE_DAY)
									);
							end
						end
						GameTooltip:AddLine(L["TIP_GLOBAL_ALT"]);
					else
						GameTooltip:AddLine(L["TIP_GLOBAL_ALT"]);
						GameTooltip:AddLine(L["TIP_GLOBAL_SHIFT"]);
					end
				end
				GameTooltip:Show();
			end
			dayLimit:SetScript("OnEnter", dayLimitOnEnter);
			dayLimit:SetScript("OnLeave", Info_OnLeave);
			dayLimit:SetScript("OnEvent", function(self)
				if GameTooltip:IsOwned(self) then
					-- GameTooltip:Hide();
					dayLimitOnEnter(self);
				end
			end);
			dayLimit:RegisterEvent("MODIFIER_STATE_CHANGED");
			function __ns.DayLimitStr(text)
				dayLimitStr:SetText(text);
			end
		-->
		-->	apply set
			if SET.enabled then
				__ns.EnableUI();
			else
				__ns.DisableUI();
			end
			if SET.locked then
				__ns.LockUI();
			else
				__ns.UnlockUI();
			end
			ui:SetPoint(unpack(SET.pos));
		-->
		C_Timer.NewTicker(1.0, __ns.updateGUI);
		return ui;
	end
	function __ns.updateGUI()
		local list = VAR.list;
		local hash = VAR.hash;
		__ns.Cleanup(list, hash);
		local now = GetServerTime();
		local num = #list;
		local num1hr = 0;
		for index = 1, min(num, 5) do
			local info = list[num - index + 1];
			if info[1] + ONE_HOUR > now then
				num1hr = index;
			else
				break;
			end
		end
		for index = 1, 5 do
			if index > num1hr then
				for index2 = index, 5 do
					__ns.LineSetText(index2, "\124cff00ff00" .. L["AVAILABLE"] .. "\124r");
					index2 = index2 + 1;
				end
				break;
			else
				local info = list[num - num1hr + index];
				if index == 1 and not SET.just_reset then
					__ns.LineSetText(index, __ns.time_to_stamp("\124cffffff00[%M:%S]\124r", info[1] - now + ONE_HOUR));
				else
					__ns.LineSetText(index, __ns.time_to_stamp("\124cffff0000[%M:%S]\124r", info[1] - now + ONE_HOUR));
				end
			end
		end
		local num24hrs = 0;
		for index = 1, num do
			local info = list[index];
			if info[4] == 'party' then
				num24hrs = num24hrs + 1;
			end
		end
		__ns.DayLimitStr(
				"\124cff00ff00" .. L["AVAILABLE_GLOBAL"] .. (DAY_LIMIT - num24hrs) .. 
				"\124r - \124cffff0000" .. 
				L["LOCK"] .. num24hrs .. "\124r");
	end	
-->		Core
	--[[	--	reduced logfile
		{ "09:47:55", "PLAYER_STARTED_MOVING", },
		{ "09:47:55", "CURSOR_UPDATE", },
		{ "09:47:55", "LOADING_SCREEN_ENABLED", },
		{ "09:47:55", "CONSOLE_MESSAGE", "World transfer pending...", 0, },
		{ "09:47:55", "PLAYER_STOPPED_MOVING", },
		{ "09:47:56", "CONSOLE_MESSAGE", "Got new connection 3", 0, },
		{ "09:47:57", "INSTANCE_LOCK_STOP", },
		{ "09:47:57", "PLAYER_LEAVING_WORLD", },
		{ "09:47:57", "ACTIONBAR_UPDATE_COOLDOWN", },
		{ "09:47:57", "SPELL_UPDATE_CHARGES", },
		{ "09:47:57", "SPELL_UPDATE_COOLDOWN", },
		{ "09:47:58", "INSTANCE_GROUP_SIZE_CHANGED", },
		{ "09:47:58", "CONSOLE_MESSAGE", "Weather changed to 0, intensity 0.000000\n", 0, },
		{ "09:47:58", "TABARD_CANSAVE_CHANGED", },
		{ "09:47:58", "PLAYER_GUILD_UPDATE", "player", },
		{ "09:47:58", "UPDATE_INVENTORY_DURABILITY", },
		{ "09:47:58", "PET_BAR_UPDATE", },
		{ "09:47:58", "UPDATE_FACTION", },
		{ "09:47:58", "UPDATE_FACTION", },
		{ "09:47:58", "SKILL_LINES_CHANGED", },
		{ "09:47:58", "INITIAL_CLUBS_LOADED", },
		{ "09:47:58", "UPDATE_ALL_UI_WIDGETS", },
		{ "09:47:58", "W", true, "party", },
		{ "09:47:58", "W", "暴风城监狱", "party", 1, "普通", 5, 0, false, 34, 5, },
		{ "09:47:58", "W", true, "party", },
		{ "09:47:58", "W", "暴风城监狱", "party", 1, "普通", 5, 0, false, 34, 5, },
		{ "09:47:58", "CORPSE_POSITION_UPDATE", },
		{ "09:47:58", "CORPSE_POSITION_UPDATE", },
		{ "09:47:58", "PLAYER_ALIVE", },
		{ "09:47:58", "PVP_TIMER_UPDATE", "player", },
		{ "09:47:58", "COMMENTATOR_ENTER_WORLD", },
		{ "09:47:59", "L", true, "party", },
		{ "09:47:59", "L", "暴风城监狱", "party", 1, "普通", 5, 0, false, 34, 5, },
		{ "09:47:59", "L", true, "party", },
		{ "09:47:59", "L", "暴风城监狱", "party", 1, "普通", 5, 0, false, 34, 5, },
		{ "09:47:59", "ACTIONBAR_UPDATE_COOLDOWN", },
		{ "09:47:59", "MINIMAP_UPDATE_ZOOM", },
		{ "09:47:59", "QUEST_LOG_UPDATE", },
		{ "09:47:59", "SPELL_UPDATE_CHARGES", },
		{ "09:47:59", "SPELL_UPDATE_COOLDOWN", },
		{ "09:47:59", "SPELLS_CHANGED", },
		{ "09:47:59", "UNIT_MODEL_CHANGED", "player", },
		{ "09:47:59", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:00", "ZONE_CHANGED_NEW_AREA", },
		{ "09:48:00", "UPDATE_ALL_UI_WIDGETS", },
		{ "09:48:00", "UNIT_FACTION", "player", },
		{ "09:48:00", "UPDATE_PENDING_MAIL", },
		{ "09:48:00", "UPDATE_INSTANCE_INFO", },
		{ "09:48:00", "GUILD_ROSTER_UPDATE", false, },
		{ "09:48:00", "S", "4894", "25735", "迪菲亚狱友", "00018D0ECE", 1594691279.855, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:00", "S", "4894", "25735", "迪菲亚狱友", "00018D0ECE", 1594691279.855, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:00", "S", "4894", "25735", "迪菲亚狱友", "00018D0ECE", 1594691279.855, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:00", "S", "4894", "25735", "迪菲亚狱友", "00018D0ECE", 1594691279.855, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:00", "ACTIONBAR_UPDATE_COOLDOWN", },
		{ "09:48:00", "AREA_POIS_UPDATED", },
		{ "09:48:00", "QUEST_LOG_UPDATE", },
		{ "09:48:00", "SPELL_UPDATE_CHARGES", },
		{ "09:48:00", "SPELL_UPDATE_COOLDOWN", },
		{ "09:48:00", "SPELLS_CHANGED", },
		{ "09:48:00", "UNIT_AURA", "player", },
		{ "09:48:00", "UNIT_MODEL_CHANGED", "player", },
		{ "09:48:00", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:00", "REQUEST_CEMETERY_LIST_RESPONSE", false, },
		{ "09:48:00", "BN_INFO_CHANGED", },
		{ "09:48:00", "BN_FRIEND_INFO_CHANGED", },
		{ "09:48:00", "BN_INFO_CHANGED", },
		{ "09:48:00", "BN_FRIEND_INFO_CHANGED", },
		{ "09:48:00", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:00", "UNIT_MODEL_CHANGED", "player", },
		{ "09:48:00", "PORTRAITS_UPDATED", },
		{ "09:48:00", "GUILD_ROSTER_UPDATE", false, },
		{ "09:48:00", "GUILD_RANKS_UPDATE", },
		{ "09:48:04", "S", "4894", "25735", "迪菲亚狱友", "00010D0ED1", 1594691284.219, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, },
		{ "09:48:04", "S", "4894", "25735", "迪菲亚狱友", "00010D0ED1", 1594691284.219, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, },
		{ "09:48:04", "S", "4894", "25735", "迪菲亚狱友", "00010D0ED1", 1594691284.219, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:04", "S", "4894", "25735", "迪菲亚狱友", "00010D0ED1", 1594691284.219, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:05", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED0", 1594691284.619, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:05", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED0", 1594691284.619, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:05", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED0", 1594691284.619, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:05", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED0", 1594691284.619, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:05", "S", "4894", "25735", "迪菲亚狱友", "00008D0ECF", 1594691285.419, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, },
		{ "09:48:05", "S", "4894", "25735", "迪菲亚狱友", "00008D0ECF", 1594691285.419, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, },
		{ "09:48:05", "S", "4894", "25735", "迪菲亚狱友", "00008D0ECF", 1594691285.419, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:05", "S", "4894", "25735", "迪菲亚狱友", "00008D0ECF", 1594691285.419, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:06", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED1", 1594691285.819, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, },
		{ "09:48:06", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED1", 1594691285.819, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, },
		{ "09:48:06", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED1", 1594691285.819, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:06", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED1", 1594691285.819, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:06", "S", "4894", "25735", "迪菲亚狱友", "00040D0ECE", 1594691286.236, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:06", "S", "4894", "25735", "迪菲亚狱友", "00040D0ECE", 1594691286.236, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:06", "S", "4894", "25735", "迪菲亚狱友", "00040D0ECE", 1594691286.236, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:06", "S", "4894", "25735", "迪菲亚狱友", "00040D0ECE", 1594691286.236, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:07", "S", "4894", "25735", "迪菲亚狱友", "00030D0ED0", 1594691286.619, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:07", "S", "4894", "25735", "迪菲亚狱友", "00030D0ED0", 1594691286.619, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:07", "S", "4894", "25735", "迪菲亚狱友", "00030D0ED0", 1594691286.619, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:07", "S", "4894", "25735", "迪菲亚狱友", "00030D0ED0", 1594691286.619, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:11", "S", "4894", "25735", "迪菲亚狱友", "00020D0ED0", 1594691291.469, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:11", "S", "4894", "25735", "迪菲亚狱友", "00020D0ED0", 1594691291.469, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:11", "S", "4894", "25735", "迪菲亚狱友", "00020D0ED0", 1594691291.469, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:11", "S", "4894", "25735", "迪菲亚狱友", "00020D0ED0", 1594691291.469, "SPELL_CAST_SUCCESS", false, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, "", nil, -2147483648, -2147483648, },
		{ "09:48:13", "PLAYER_STARTED_MOVING", },
		{ "09:48:13", "CURSOR_UPDATE", },
		{ "09:48:13", "LOADING_SCREEN_ENABLED", },
		{ "09:48:13", "CONSOLE_MESSAGE", "World transfer pending...", 0, },
		{ "09:48:14", "PLAYER_STOPPED_MOVING", },
		{ "09:48:15", "CONSOLE_MESSAGE", "Got new connection 3", 0, },
		{ "09:48:15", "INSTANCE_LOCK_STOP", },
		{ "09:48:15", "PLAYER_LEAVING_WORLD", },
		{ "09:48:16", "ACTIONBAR_UPDATE_COOLDOWN", },
		{ "09:48:16", "SPELL_UPDATE_CHARGES", },
		{ "09:48:16", "SPELL_UPDATE_COOLDOWN", },
		{ "09:48:17", "CONSOLE_MESSAGE", "Weather changed to 0, intensity 0.000000\n", 0, },
		{ "09:48:17", "TABARD_CANSAVE_CHANGED", },
		{ "09:48:17", "PLAYER_GUILD_UPDATE", "player", },
		{ "09:48:17", "UPDATE_INVENTORY_DURABILITY", },
		{ "09:48:17", "PET_BAR_UPDATE", },
		{ "09:48:17", "UPDATE_FACTION", },
		{ "09:48:17", "UPDATE_FACTION", },
		{ "09:48:17", "SKILL_LINES_CHANGED", },
		{ "09:48:17", "INITIAL_CLUBS_LOADED", },
		{ "09:48:17", "UPDATE_ALL_UI_WIDGETS", },
		{ "09:48:17", "W", false, "none", },
		{ "09:48:17", "W", "东部王国", "none", 0, "", 0, 0, false, 0, 0, },
		{ "09:48:17", "W", false, "none", },
		{ "09:48:17", "W", "东部王国", "none", 0, "", 0, 0, false, 0, 0, },
		{ "09:48:17", "CORPSE_POSITION_UPDATE", },
		{ "09:48:17", "CORPSE_POSITION_UPDATE", },
		{ "09:48:17", "PLAYER_ALIVE", },
		{ "09:48:17", "PVP_TIMER_UPDATE", "player", },
		{ "09:48:17", "COMMENTATOR_ENTER_WORLD", },
		{ "09:48:18", "L", false, "none", },
		{ "09:48:18", "L", "东部王国", "none", 0, "", 0, 0, false, 0, 0, },
		{ "09:48:18", "L", false, "none", },
		{ "09:48:18", "L", "东部王国", "none", 0, "", 0, 0, false, 0, 0, },
		{ "09:48:18", "ACTIONBAR_UPDATE_COOLDOWN", },
		{ "09:48:18", "MINIMAP_UPDATE_ZOOM", },
		{ "09:48:18", "QUEST_LOG_UPDATE", },
		{ "09:48:18", "SPELL_UPDATE_CHARGES", },
		{ "09:48:18", "SPELL_UPDATE_COOLDOWN", },
		{ "09:48:18", "SPELLS_CHANGED", },
		{ "09:48:18", "UNIT_MODEL_CHANGED", "player", },
		{ "09:48:18", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:18", "UNIT_MAXHEALTH", "player", },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-4995-00018D0273", "监狱守卫", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-4995-00018D0273", "监狱守卫", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-4995-00000D0273", "监狱守卫", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-4995-00000D0273", "监狱守卫", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-6237-00000D025E", "监狱弓箭手", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-6237-00000D025E", "监狱弓箭手", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-4995-00010D0273", "监狱守卫", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-4995-00010D0273", "监狱守卫", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-4995-00008D0273", "监狱守卫", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-4995-00008D0273", "监狱守卫", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-6237-00008D0278", "监狱弓箭手", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-6237-00008D0278", "监狱弓箭手", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-5042-00000637EF", "护士莉莲", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-5042-00000637EF", "护士莉莲", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-6237-00000D0278", "监狱弓箭手", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-6237-00000D0278", "监狱弓箭手", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-6237-00008D025E", "监狱弓箭手", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-6237-00008D025E", "监狱弓箭手", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-68-00018637F0", "暴风城卫兵", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-68-00018637F0", "暴风城卫兵", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-68-00010637EF", "暴风城卫兵", 2584, 0, },
		{ "09:48:18", "S", "4955", "133", "玛丁雷少校", "00000637EF", 1594691297.626, "SPELL_AURA_APPLIED", false, "Creature-0-4955-0-133-14394-00000637EF", "玛丁雷少校", 2600, 0, "Creature-0-4955-0-133-68-00010637EF", "暴风城卫兵", 2584, 0, },
		{ "09:48:18", "UNIT_FACTION", "player", },
		{ "09:48:18", "QUEST_LOG_UPDATE", },
		{ "09:48:18", "UNIT_AURA", "player", },
		{ "09:48:18", "UNIT_MODEL_CHANGED", "player", },
		{ "09:48:18", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:18", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:18", "UNIT_MODEL_CHANGED", "player", },
		{ "09:48:18", "PORTRAITS_UPDATED", },
		{ "09:48:18", "ZONE_CHANGED_NEW_AREA", },
		{ "09:48:18", "UPDATE_ALL_UI_WIDGETS", },
		{ "09:48:18", "AREA_POIS_UPDATED", },
		{ "09:48:18", "UPDATE_INSTANCE_INFO", },
		{ "09:48:18", "GUILD_ROSTER_UPDATE", false, },
		{ "09:48:18", "UPDATE_PENDING_MAIL", },
		{ "09:48:18", "GUILD_ROSTER_UPDATE", false, },
		{ "09:48:18", "GUILD_RANKS_UPDATE", },
		{ "09:48:19", "REQUEST_CEMETERY_LIST_RESPONSE", false, },
		{ "09:48:20", "BN_INFO_CHANGED", },
		{ "09:48:20", "BN_FRIEND_INFO_CHANGED", },
		{ "09:48:20", "BN_INFO_CHANGED", },
		{ "09:48:20", "BN_FRIEND_INFO_CHANGED", },
		{ "09:48:23", "CONSOLE_MESSAGE", "DBCache::CancelCallback ignored", 0, },
		{ "09:48:31", "PLAYER_STARTED_MOVING", },
		{ "09:48:32", "CURSOR_UPDATE", },
		{ "09:48:32", "LOADING_SCREEN_ENABLED", },
		{ "09:48:32", "CONSOLE_MESSAGE", "World transfer pending...", 0, },
		{ "09:48:33", "PLAYER_STOPPED_MOVING", },
		{ "09:48:33", "CONSOLE_MESSAGE", "Got new connection 3", 0, },
		{ "09:48:34", "INSTANCE_LOCK_STOP", },
		{ "09:48:34", "PLAYER_LEAVING_WORLD", },
		{ "09:48:34", "ACTIONBAR_UPDATE_COOLDOWN", },
		{ "09:48:34", "SPELL_UPDATE_CHARGES", },
		{ "09:48:34", "SPELL_UPDATE_COOLDOWN", },
		{ "09:48:35", "INSTANCE_GROUP_SIZE_CHANGED", },
		{ "09:48:35", "CONSOLE_MESSAGE", "Weather changed to 0, intensity 0.000000\n", 0, },
		{ "09:48:35", "TABARD_CANSAVE_CHANGED", },
		{ "09:48:35", "PLAYER_GUILD_UPDATE", "player", },
		{ "09:48:35", "UPDATE_INVENTORY_DURABILITY", },
		{ "09:48:35", "PET_BAR_UPDATE", },
		{ "09:48:35", "UPDATE_FACTION", },
		{ "09:48:35", "UPDATE_FACTION", },
		{ "09:48:35", "SKILL_LINES_CHANGED", },
		{ "09:48:35", "INITIAL_CLUBS_LOADED", },
		{ "09:48:35", "UPDATE_ALL_UI_WIDGETS", },
		{ "09:48:35", "W", true, "party", },
		{ "09:48:35", "W", "暴风城监狱", "party", 1, "普通", 5, 0, false, 34, 5, },
		{ "09:48:35", "W", true, "party", },
		{ "09:48:35", "W", "暴风城监狱", "party", 1, "普通", 5, 0, false, 34, 5, },
		{ "09:48:35", "CORPSE_POSITION_UPDATE", },
		{ "09:48:35", "CORPSE_POSITION_UPDATE", },
		{ "09:48:35", "PLAYER_ALIVE", },
		{ "09:48:35", "PVP_TIMER_UPDATE", "player", },
		{ "09:48:35", "COMMENTATOR_ENTER_WORLD", },
		{ "09:48:35", "L", true, "party", },
		{ "09:48:35", "L", "暴风城监狱", "party", 1, "普通", 5, 0, false, 34, 5, },
		{ "09:48:35", "L", true, "party", },
		{ "09:48:35", "L", "暴风城监狱", "party", 1, "普通", 5, 0, false, 34, 5, },
		{ "09:48:35", "ACTIONBAR_UPDATE_COOLDOWN", },
		{ "09:48:35", "MINIMAP_UPDATE_ZOOM", },
		{ "09:48:35", "QUEST_LOG_UPDATE", },
		{ "09:48:35", "SPELL_UPDATE_CHARGES", },
		{ "09:48:35", "SPELL_UPDATE_COOLDOWN", },
		{ "09:48:35", "SPELLS_CHANGED", },
		{ "09:48:35", "UNIT_MODEL_CHANGED", "player", },
		{ "09:48:35", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:35", "UNIT_MAXHEALTH", "player", },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00030D0ED0", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00030D0ED0", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00030D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00040D0ECE", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00040D0ECE", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00040D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00000D0ED0", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00000D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00000D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00000D0ED0", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00000D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00000D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED0", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED0", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00010D0ED1", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00010D0ED1", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00010D0ED1", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00008D0ECF", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00008D0ECF", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ECF", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED1", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00008D0ED1", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00008D0ED1", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00020D0ED0", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00020D0ED0", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00020D0ED0", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00018D0ECE", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "S", "4894", "25735", "迪菲亚狱友", "00018D0ECE", 1594691315.507, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00018D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:35", "UNIT_FACTION", "player", },
		{ "09:48:35", "UPDATE_INSTANCE_INFO", },
		{ "09:48:35", "GUILD_ROSTER_UPDATE", false, },
		{ "09:48:35", "UPDATE_PENDING_MAIL", },
		{ "09:48:35", "ACTIONBAR_UPDATE_COOLDOWN", },
		{ "09:48:35", "QUEST_LOG_UPDATE", },
		{ "09:48:35", "SPELL_UPDATE_CHARGES", },
		{ "09:48:35", "SPELL_UPDATE_COOLDOWN", },
		{ "09:48:35", "UNIT_AURA", "player", },
		{ "09:48:35", "UNIT_MODEL_CHANGED", "player", },
		{ "09:48:35", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:36", "UNIT_PORTRAIT_UPDATE", "player", },
		{ "09:48:36", "UNIT_MODEL_CHANGED", "player", },
		{ "09:48:36", "PORTRAITS_UPDATED", },
		{ "09:48:36", "ZONE_CHANGED_NEW_AREA", },
		{ "09:48:36", "UPDATE_ALL_UI_WIDGETS", },
		{ "09:48:36", "AREA_POIS_UPDATED", },
		{ "09:48:36", "GUILD_ROSTER_UPDATE", false, },
		{ "09:48:36", "GUILD_RANKS_UPDATE", },
		{ "09:48:37", "REQUEST_CEMETERY_LIST_RESPONSE", false, },
		{ "09:48:40", "BN_INFO_CHANGED", },
		{ "09:48:40", "BN_FRIEND_INFO_CHANGED", },
		{ "09:48:40", "BN_INFO_CHANGED", },
		{ "09:48:40", "BN_FRIEND_INFO_CHANGED", },
		{ "09:48:41", "S", "4894", "25735", "迪菲亚狱友", "00028D0ECE", 1594691320.932, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00028D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00028D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:41", "S", "4894", "25735", "迪菲亚狱友", "00028D0ECE", 1594691320.932, "SPELL_AURA_APPLIED", false, "Creature-0-4894-34-25735-1708-00028D0ECE", "迪菲亚狱友", 2632, 0, "Creature-0-4894-34-25735-1708-00028D0ECE", "迪菲亚狱友", 2632, 0, },
		{ "09:48:48", "INSTANCE_LOCK_STOP", },
		{ "09:48:48", "PLAYER_LEAVING_WORLD", },
		{ "09:48:48", "CURSOR_UPDATE", },
		{ "09:48:48", "TRADE_SKILL_CLOSE", },
		{ "09:48:48", "ADDONS_UNLOADING", true, },
		{ "09:48:48", "PLAYER_LOGOUT", },
	--]]
	--[[		--	VAR format
			@char{  }
				@hash{  }	[uid] = GetServerTime()
				@list{  }	{ GetServerTime(), zoneUID, instanceID, instanceType, serverID, }
	--]]
	--
	--[[		--	GUID format
		For players: 									"Player-[server ID]-[player UID]"
		Example: 										"Player-970-0002FD64"
		For creatures, pets, objects, and vehicles: 	"[Unit type]-0-[server ID]-[instance ID]-[zone UID]-[ID]-[spawn UID]"
		Example: 										"Creature-0-970-0-11-31146-000136DF91"
		Unit Type Names: "Creature", "Pet", "GameObject", "Vehicle", and "Vignette"
		For items:										"Item-[server ID]-0-[spawn UID]"
		Example: 										"Item-970-0-400000076620BFF4"
		Please note that this tells you nothing useful about the item, like the ID
		Creature-0-4539-389-28244-11320-00028C1038
		Creature-0-4528-389-18991-11320-00040C106F
	--]]
	--[[
		--	UNIT_TARGET	unitId
		--	UPDATE_MOUSEOVER_UNIT
		--	NAME_PLATE_CREATED	namePlateFrame
		--	NAME_PLATE_UNIT_ADDED	unitId
		--	COMBAT_LOG_EVENT_UNFILTERED, COMBAT_LOG_EVENT
		--	local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = CombatLogGetCurrentEventInfo()
	--]]
	--[[
		进入副本，保存instanceID到SET._var_capturingInstanceID >>
		通过玩家和队友目标、鼠标悬浮、战斗日志、姓名版获取Creature类型GUID【则通过判断instanceID来过滤世界BUFF事件】 >>
		#1	捕获信息成功 >> 重置变量，结束
				##	捕获INSTANCE_RESET_SUCCESS后 或 出本300秒后  设置SET.just_reset = true
					#	SET.just_reset == true 时	黄色显示最后一次进度
					#	否则						红色显示最后一次进度
		#2	未捕获到信息
				#1	副本内捕获INSTANCE_RESET_FAILED消息 设置SET._var_resetting = true，出本后记录一次进度		开始或结束捕获时重置SET._var_resetting
				#2	出本后，设置SET._var_saveOnNextReset = true
					#1	副本外捕获INSTANCE_RESET_SUCCESS后，if SET._var_saveOnNextReset == true，记录一次进度
					#2	进入不同的副本，if SET._var_saveOnNextReset == true，记录一次进度
		#	捕获RESET_FAILED_NOTIFY消息，设置SET.just_reset = true
	--]]
	--		ContinentID	@//DB//AreaTable
	--	actually unnecessary
	--	https://wow.gamepedia.com/InstanceID/Complete_list
	-->
		__ns.InstanceIDHash = {
			-->		Continents / Zones
				[0] = false,		--	Eastern Kingdoms
				[1] = false,		--	Kalimdor
				[530] = false,		--	The Burning Crusade	Outland
				[571] = false,		--	Wrath of the Lich King	Northrend
				[646] = false,		--	Cataclysm	Deepholm
				[730] = false,		--	Cataclysm	Maelstrom Zone
				[732] = false,		--	Cataclysm	Tol Barad
				[860] = false,		--	Mists of Pandaria	The Wandering Isle
				[870] = false,		--	Mists of Pandaria	Pandaria
				[1064] = false,		--	Mists of Pandaria	Isle of Thunder
				[1116] = false,		--	Warlords of Draenor	Draenor
				[1191] = false,		--	Warlords of Draenor	Ashran
				[1464] = false,		--	Warlords of Draenor	Tanaan Jungle
				[1220] = false,		--	Legion	Broken Isles
				[1669] = false,		--	Legion	Argus
				[1642] = false,		--	Battle for Azeroth	Zandalar
				[1643] = false,		--	Battle for Azeroth	Kul Tiras
				[1718] = false,		--	Battle for Azeroth	Nazjatar
			-->		Battlegrounds
				[30] = false,		--	Alterac Valley
				[529] = false,		--	Arathi Basin (Classic)
				[1681] = false,		--	Arathi Basin (Winter)
				[2107] = false,		--	Arathi Basin
				[2177] = false,		--	Arathi Basin Comp Stomp
				[1105] = false,		--	Deepwind Gorge
				[566] = false,		--	Eye of the Storm
				[968] = false,		--	Eye of the Storm (Rated)
				[628] = false,		--	Isle of Conquest
				[1803] = false,		--	Seething Shore
				[727] = false,		--	Silvershard Mines
				[607] = false,		--	Strand of the Ancients
				[998] = false,		--	Temple of Kotmogu
				[761] = false,		--	The Battle for Gilneas
				[726] = false,		--	Twin Peaks
				[489] = false,		--	Warsong Gulch
			-->		Arenas
				[562] = false,		--	Blade's Edge Arena
				[617] = false,		--	Dalaran Arena
				[559] = false,		--	Nagrand Arena
				[572] = false,		--	Ruins of Lordaeron
				[618] = false,		--	The Ring of Valor
				[1134] = false,		--	Tiger's Peak
				[980] = false,		--	Tol'Viron Arena
				[2167] = false,		--	The Robodrome
			-->		Dungeons
				--	Vanilla
					[389] = true,		--	Ragefire Chasm
					[43] = true,		--	Wailing Caverns
					[36] = true,		--!	The Deadmines
					[33] = true,		--	Shadowfang Keep
					[48] = true,		--	Blackfathom Deeps
					[34] = true,		--!	The Stockade
					[47] = true,		--	Razorfen Kraul
					[90] = true,		--!	Gnomeregan
					[189] = true,		--!	Scarlet Monastery
					[129] = true,		--	Razorfen Downs
					[70] = true,		--!	Uldaman
					[349] = true,		--	Maraudon
					[209] = true,		--	Zul'Farrak
					[109] = true,		--	The Temple of Atal'Hakkar	--	Sunken Temple
					[230] = true,		--!	Blackrock Depths
					[429] = true,		--	Dire Maul
					[329] = true,		--!	Stratholme
					[229] = true,		--!	Blackrock Spire
					[289] = true,		--!	Scholomance
					--	refored CTM
					[1001] = true,		--[CTM]	Scarlet Halls
					[1004] = true,		--[CTM]	Scarlet Monastery
					[1007] = true,		--[CTM]	Scholomance
				--	Burning Crusade
					[558] = true,		--	Auchenai Crypts
					[543] = true,		--	Hellfire Ramparts
					[585] = true,		--	Magisters' Terrace
					[557] = true,		--	Mana-Tombs
					[560] = true,		--	Old Hillsbrad Foothills
					[556] = true,		--	Sethekk Halls
					[555] = true,		--	Shadow Labyrinth
					[552] = true,		--	The Arcatraz
					[269] = true,		--	The Black Morass
					[542] = true,		--	The Blood Furnace
					[553] = true,		--	The Botanica
					[554] = true,		--	The Mechanar
					[540] = true,		--	The Shattered Halls
					[547] = true,		--	The Slave Pens
					[545] = true,		--	The Steamvault
					[546] = true,		--	The Underbog
				--	Wrath
					[619] = true,		--	Ahn'kahet: The Old Kingdom
					[601] = true,		--	Azjol-Nerub
					[600] = true,		--	Drak'Tharon Keep
					[604] = true,		--	Gundrak
					[602] = true,		--	Halls of Lightning
					[668] = true,		--	Halls of Reflection
					[599] = true,		--	Halls of Stone
					[658] = true,		--	Pit of Saron
					[595] = true,		--	The Culling of Stratholme
					[632] = true,		--	The Forge of Souls
					[576] = true,		--	The Nexus
					[578] = true,		--	The Oculus
					[608] = true,		--	The Violet Hold
					[650] = true,		--	Trial of the Champion
					[574] = true,		--	Utgarde Keep
					[575] = true,		--	Utgarde Pinnacle
				--	Cataclysm
					[645] = true,		--	Blackrock Caverns
					[938] = true,		--	End Time
					[670] = true,		--	Grim Batol
					[644] = true,		--	Halls of Origination
					[940] = true,		--	Hour of Twilight
					[755] = true,		--	Lost City of the Tol'vir
					[725] = true,		--	The Stonecore
					[657] = true,		--	The Vortex Pinnacle
					[643] = true,		--	Throne of the Tides
					[939] = true,		--	Well of Eternity
					[568] = true,		--	Zul'Aman
					[859] = true,		--	Zul'Gurub
				--	Pandaria
					[962] = true,		--	Gate of the Setting Sun
					[994] = true,		--	Mogu'Shan Palace
					[959] = true,		--	Shado-pan Monastery
					[1011] = true,		--	Siege of Niuzao Temple
					[961] = true,		--	Stormstout Brewery
					[960] = true,		--	Temple of the Jade Serpent
				--	Warlords
					[1182] = true,		--	Auchindoun
					[1175] = true,		--	Bloodmaul Slag Mines
					[1208] = true,		--	Grimrail Depot
					[1195] = true,		--	Iron Docks
					[1176] = true,		--	Shadowmoon Burial Grounds
					[1209] = true,		--	Skyreach
					[1279] = true,		--	The Everbloom
					[1358] = true,		--	Upper Blackrock Spire
				--	Legion
					[1501] = true,		--	Black Rook Hold
					[1677] = true,		--	Cathedral of Eternal Night
					[1571] = true,		--	Court of Stars
					[1466] = true,		--	Darkheart Thicket
					[1456] = true,		--	Eye of Azshara
					[1477] = true,		--	Halls of Valor
					[1492] = true,		--	Maw of Souls
					[1458] = true,		--	Neltharion's Lair
					[1651] = true,		--	Return to Karazhan
					[1753] = true,		--	Seat of the Triumvirate
					[1516] = true,		--	The Arcway
					[1493] = true,		--	Vault of the Wardens
					[1544] = true,		--	Violet Hold
				--	BFA
					[1763] = true,		--	Atal'Dazar
					[1754] = true,		--	Freehold
					[1762] = true,		--	Kings' Rest
					[1864] = true,		--	Shrine of the Storm
					[1822] = true,		--	Siege of Boralus
					[1877] = true,		--	Temple of Sethraliss
					[1594] = true,		--	The MOTHERLODE!!
					[1841] = true,		--	The Underrot
					[1771] = true,		--	Tol Dagor
					[1862] = true,		--	Waycrest Manor
					[2097] = true,		--	Operation: Mechagon
			-->		Raids
				--	Vanilla
					[309] = true,		--!	Zul'Gurub
					[509] = true,		--	Ruins of Ahn'Qiraj
					[409] = true,		--	Molten Core
					[249] = true,		--!	Onyxia's Lair			--	seem to be the same with the Wrath copy
					[469] = true,		--	Blackwing Lair
					[531] = true,		--	Temple of Ahn'Qiraj
					[533] = true,		--	Naxxramas??
				--	Burning Crusade
					[564] = true,		--	Black Temple
					[565] = true,		--	Gruul's Lair
					[534] = true,		--	Hyjal Summit
					[532] = true,		--	Karazhan
					[544] = true,		--	Magtheridon's Lair
					[548] = true,		--	Serpentshrine Cavern
					[580] = true,		--	Sunwell Plateau
					[550] = true,		--	Tempest Keep
				--	Wrath
					[631] = true,		--	Icecrown Citadel
					[533] = true,		--	Naxxramas
					[249] = true,		--	Onyxia's Lair
					[616] = true,		--	The Eye of Eternity
					[615] = true,		--	The Obsidian Sanctum
					[724] = true,		--	The Ruby Sanctum
					[649] = true,		--	Trial of the Crusader
					[603] = true,		--	Ulduar
					[624] = true,		--	Vault of Archavon
				--	Cataclysm
					[757] = true,		--	Baradin Hold
					[669] = true,		--	Blackwing Descent
					[967] = true,		--	Dragon Soul
					[720] = true,		--	Firelands
					[671] = true,		--	The Bastion of Twilight
					[754] = true,		--	Throne of the Four Winds
				--	Pandaria
					[1009] = true,		--	Heart of Fear
					[1008] = true,		--	Mogu'shan Vaults
					[1136] = true,		--	Siege of Orgrimmar
					[996] = true,		--	Terrace of Endless Spring
					[1098] = true,		--	Throne of Thunder
				--	Warlords
					[1228] = true,		--	Highmaul
					[1205] = true,		--	Blackrock Foundry
					[1448] = true,		--	Hellfire Citadel
				--	Legion
					[1520] = true,		--	The Emerald Nightmare
					[1648] = true,		--	Trial of Valor
					[1530] = true,		--	The Nighthold
					[1676] = true,		--	Tomb of Sargeras
					[1712] = true,		--	Antorus, the Burning Throne
				--	BFA
					[1861] = true,		--	Uldir
					[2070] = true,		--	Battle of Dazar'alor
					[2096] = true,		--	Crucible of Storms
					[2164] = true,		--	The Eternal Palace
					[2217] = true,		--	Ny’alotha
		};
		function __ns.Cleanup(list, hash)
			if #list > 0 then
				local now = GetServerTime();
				local info = list[1];
				while info[1] + ONE_DAY < now do
					tremove(list, 1);
					hash[info[2]] = nil;
					info = list[1];
				end
			end
		end
		function __ns.SaveZoneUID(zoneUID, instanceID, serverID)
			SET._var_capturingInstanceID = nil;
			local list = VAR.list;
			local hash = VAR.hash;
			local rtime = SET._var_instanceType;
			if hash[zoneUID] == nil then
				hash[zoneUID] = rtime;
				tinsert(list, { rtime, zoneUID, instanceID, SET._var_instanceType, serverID, });
				__ns.updateGUI();
			else
			end
			if __ns.InstanceIDHash[instanceID] ~= true then
				__log__('instanceID_Hash[instanceID]', instanceID, SET._var_instanceID);
			end
		end
		function __ns.ON_GUID_CAPTURED(GUID)
			local _type, _, serverID, instanceID, zoneUID, creatureType, spawnID = strsplit("-", GUID);
			instanceID = tonumber(instanceID);
			__log__('instanceID', instanceID, SET._var_instanceID);
			if instanceID == SET._var_instanceID then
				__ns.StopCapturing();
				__ns.SaveZoneUID(tonumber(zoneUID), instanceID, tonumber(serverID));
			end
		end
		function __ns.StartCapturing(instanceID, instanceType)
			-- if SET._var_saveOnNextReset and SET._var_instanceID and SET._var_instanceID ~= instanceID then
			-- 	__ns.SimcLock();
			-- end
			-- SET.just_reset = nil;
			-- SET._var_saveOnNextReset = nil;
			--
			SET._var_capturing = true;
			SET._var_instanceID = instanceID;
			SET._var_instanceType = instanceType;
			SET._var_instanceType = GetServerTime();
			SET._var_capturingInstanceID = instanceID;
			SET._var_resetting = nil;
			_EventHandler:RegEvent("UNIT_TARGET");
			_EventHandler:RegEvent("UPDATE_MOUSEOVER_UNIT");
			_EventHandler:RegEvent("NAME_PLATE_UNIT_ADDED");
			_EventHandler:RegEvent("COMBAT_LOG_EVENT_UNFILTERED");
		end
		function __ns.StopCapturing()
			SET._var_capturing = nil;
			SET._var_resetting = nil;
			_EventHandler:UnregEvent("UNIT_TARGET");
			_EventHandler:UnregEvent("UPDATE_MOUSEOVER_UNIT");
			_EventHandler:UnregEvent("NAME_PLATE_UNIT_ADDED");
			_EventHandler:UnregEvent("COMBAT_LOG_EVENT_UNFILTERED");
		end
		function __ns.SimcLock()
			SET._var_capturingInstanceID = nil;
			local rtime = SET._var_instanceType or SET.instanceTime;
			local instanceID = SET._var_instanceID or SET.instanceID;
			local instanceType = SET._var_instanceType or SET.instanceType;
			if rtime and instanceID and instanceType then
				local key = 'simc' .. date("[%H:%M:%S]", rtime);
				VAR.hash[key] = rtime;
				tinsert(VAR.list, { rtime, key, instanceID, instanceType, 'simc', });
				SET._var_saveOnNextReset = nil;
				SET.instanceTime = nil;
				SET.instanceID = nil;
				SET.instanceType = nil;
			end
			__log__('\124cffff0000Manual\124r');
		end
		local function AutoResetOnUpdate(self, elasped)
			SET.timer_to_auto_reset = SET.timer_to_auto_reset - elasped;
			if SET.timer_to_auto_reset <= 0 then
				if IsInGroup() then
					local iname = GetRealZoneText(SET._var_instanceID);
					for index = 1, GetNumGroupMembers() do
						local zone = select(7, GetRaidRosterInfo(index));
						if zone == iname then
							SET.timer_to_auto_reset = 300;
							return;
						end
					end
				end
				_EventHandler:SetScript("OnUpdate", nil);
				SET.just_reset = true;
				__ns.timer_to_auto_reset = nil;
				__log__(SET.timer_to_auto_reset, SET.just_reset);
				if SET._var_capturingInstanceID ~= nil then
					__ns.SimcLock();
				end
			end
		end
		function __ns.StartTimer(len)
			SET.instanceTime = SET._var_instanceType;
			SET.instanceID = SET._var_instanceID;
			SET.instanceType = SET._var_instanceType;
			SET.timer_to_auto_reset = len;
			_EventHandler:SetScript("OnUpdate", AutoResetOnUpdate);
		end
		function __ns.StopTimer()
			_EventHandler:SetScript("OnUpdate", nil);
			SET.timer_to_auto_reset = -1;
		end
	-->		event handlers
		function __ns.CHAT_MSG_SYSTEM(msg)do return end
			if msg == RESET_FAILED_NOTIFY then
				SET._var_resetting = true;
			else
				local _, instance;
				if __ns.bak_INSTANCE_RESET_SUCCESS ~= INSTANCE_RESET_SUCCESS then
					__ns.bak_INSTANCE_RESET_SUCCESS = INSTANCE_RESET_SUCCESS;
					__ns.instance_reset_success_pattern = gsub(INSTANCE_RESET_SUCCESS, "%%s", "(.+)");
				end
				_, _, instance = strfind(msg, __ns.instance_reset_success_pattern);
				if instance then
					if IsInRaid() then
						SendChatMessage(msg, 'RAID');
					elseif IsInGroup() then
						SendChatMessage(msg, 'PARTY');
					end
					if SET._var_saveOnNextReset then
						__ns.SimcLock();
					end
					SET.just_reset = true;
				else
					if __ns.bak_INSTANCE_RESET_FAILED ~= INSTANCE_RESET_FAILED then
						__ns.bak_INSTANCE_RESET_FAILED = INSTANCE_RESET_FAILED;
						__ns.instance_reset_failed_pattern = gsub(INSTANCE_RESET_FAILED, "%%s", "(.+)");
					end
					_, _, instance = strfind(msg, __ns.instance_reset_failed_pattern);
					if instance then
						if IsInRaid() then
							SendChatMessage(format(L["RESET"], instance), 'RAID');
						elseif IsInGroup() then
							SendChatMessage(format(L["RESET"], instance), 'PARTY');
						end
						SET.just_reset = true;
					end
				end
			end
		end
		function __ns.UNIT_TARGET(unit)
			local GUID = UnitGUID(unit .. 'target');
			if GUID and strsub(GUID, 1, 8) == "Creature" then
				__ns.ON_GUID_CAPTURED(GUID);
				__log__('T', GUID);
			end
		end
		function __ns.UPDATE_MOUSEOVER_UNIT()
			local GUID = UnitGUID('mouseover');
			if GUID and strsub(GUID, 1, 8) == "Creature" then
				__ns.ON_GUID_CAPTURED(GUID);
				__log__('M', GUID);
			end
		end
		function __ns.NAME_PLATE_UNIT_ADDED(unit)
			local GUID = UnitGUID(unit);
			if GUID and strsub(GUID, 1, 8) == "Creature" then
				__ns.ON_GUID_CAPTURED(GUID);
				__log__('N', GUID);
			end
		end
		function __ns.COMBAT_LOG_EVENT_UNFILTERED()
			local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, _12, _13, _14, _15 = CombatLogGetCurrentEventInfo();
			if strsub(sourceGUID, 1, 8) == "Creature" then
				-- --	1	1594694500.953, "SPELL_AURA_APPLIED", false, "Creature-0-4956-1-338-4949-0000063A25", "未知目标", 2600, 0, "Player-4521-010827EA", "战氏", 1297, 0, 
				-- --	12	0, "酋长的祝福", 1, "BUFF",
				-- --	SPELL_AURA	15th ~= "BUFF"
				-- if strsub(destGUID, 1, 6) == "Player" and strsub(event, 1, 10) == "SPELL_AURA" and _15 == "BUFF" then		--	skip world buff		--	check this by instanceID now
				-- 	return;
				-- end
				__ns.ON_GUID_CAPTURED(sourceGUID);
				__log__('S', sourceGUID);
			elseif strsub(destGUID, 1, 8) == "Creature" then
				__ns.ON_GUID_CAPTURED(destGUID);
				__log__('D', destGUID);
			end
		end
		function __ns._LOADING_SCREEN_DISABLED()
			local inInstance, instanceType = IsInInstance();
			__log__('L', inInstance, instanceType);
			if inInstance then
				local name, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty, isDynamic, instanceID, instanceGroupSize, LfgDungeonID = GetInstanceInfo();
				__ns.StartCapturing(tonumber(instanceID), instanceType);
				-- __ns.StopTimer();
			else
				-- if SET._var_capturingInstanceID then
				-- 	if SET._var_resetting then
				-- 		__ns.SimcLock();
				-- 		SET.just_reset = true;
				-- 	else
				-- 		SET._var_saveOnNextReset = true;
				-- 	end
				-- end
				__ns.StopCapturing();
				-- __ns.StartTimer(300);
			end
		end
	-->
-->
-->		Initialize
	local _def = {
		enabled = true,
		locked = false,
		pos = { "CENTER", "UIParent", "CENTER", 320, -160, },
		timer_to_auto_reset = -1,
	};
	function __ns.GetDefPos()
		return unpack(_def.pos);
	end
	function __ns.init_variables()
		if InstLockSV == nil then
			InstLockSV = {
				use_global_set = true,
				set = { ['*'] = {  }, },
				var = {  },
				_version = 20200714.0,
			};
		end
		if InstLockSV._version == nil or InstLockSV._version < 20200714.0 then
			wipe(InstLockSV);
			InstLockSV.use_global_set = true;
			InstLockSV.set = { ['*'] = {  }, };
			InstLockSV.var = {  };
			InstLockSV._version = 20200714.0;
		end
		if InstLockSV._version < 20200715.0 then
			local AVAR = InstLockSV.var;
			for GUID, VAR in next, AVAR do
				local list = VAR.list;
				if list ~= nil then
					for index, info in next, list do
						tinsert(info, 4, 'party');
					end
				end
			end
			InstLockSV._version = 20200715.0;
		end
		local GUID = UnitGUID('player');
		--
		local key = InstLockSV.use_global_set and '*' or GUID;
		if InstLockSV.set[key] == nil then
			InstLockSV.set[key] = {  };
		end
		SET = setmetatable(InstLockSV.set[key], { __index = _def, });
		--
		VAR = InstLockSV.var[GUID];
		if VAR == nil then
			VAR = {
				list = {  },
				hash = {  },
			};
			InstLockSV.var[GUID] = VAR;
		else
			local list = VAR.list;
			local hash = VAR.hash;
			__ns.Cleanup(list, hash);
			local temp = {  };
			for _, v in next, list do
				temp[v[2]] = true;
			end
			for zoneUID, _ in next, hash do
				if temp[zoneUID] == nil then
					error(L["VARIABLES_ERROR"]);
				end
			end
			for zoneUID, _ in next, temp do
				if hash[zoneUID] == nil then
					error(L["VARIABLES_ERROR"]);
				end
			end
		end
	end
	function __ns.init()
		__ns.init_variables();
		__ns.ui = __ns.initUI();
		for iid, val in next, __ns.InstanceIDHash do
			__ns.InstanceIDHash[tostring(iid)] = val;
		end
		--
		__ns.LOADING_SCREEN_DISABLED = __ns._LOADING_SCREEN_DISABLED;
		__ns._LOADING_SCREEN_DISABLED();
		__ns._LOADING_SCREEN_DISABLED = nil;
		--
		__ns.bak_INSTANCE_RESET_FAILED = INSTANCE_RESET_FAILED;
		__ns.instance_reset_failed_pattern = gsub(INSTANCE_RESET_FAILED, "%%s", "(.+)");
		__ns.bak_INSTANCE_RESET_SUCCESS = INSTANCE_RESET_SUCCESS;
		__ns.instance_reset_success_pattern = gsub(INSTANCE_RESET_SUCCESS, "%%s", "(.+)");
		_EventHandler:RegEvent("CHAT_MSG_SYSTEM");
		-- if SET.logoutTime ~= nil then
		-- 	if GetServerTime() - SET.logoutTime > ONE_DAY then
		-- 		SET._var_capturingInstanceID = nil;
		-- 	end
		-- end
		-- if SET.timer_to_auto_reset > 0 then
		-- 	if SET.logoutTime ~= nil then
		-- 		local diff = GetServerTime() - SET.logoutTime;
		-- 		if diff < ONE_DAY then
		-- 			__ns.StartTimer(SET.timer_to_auto_reset - diff);
		-- 		end
		-- 	end
		-- end
	end
	__ns.LOADING_SCREEN_DISABLED = __ns.init;
	_EventHandler:RegEvent("LOADING_SCREEN_DISABLED");
-->		SLASH
	_G.SLASH_ALAINSTANCETIMER1 = "/alainstancetimer";
	_G.SLASH_ALAINSTANCETIMER2 = "/alainsttimer";
	_G.SLASH_ALAINSTANCETIMER3 = "/alainst";
	_G.SLASH_ALAINSTANCETIMER4 = "/ait";
	_G.SLASH_ALAINSTANCETIMER5 = "/instancelockedo";
	_G.SLASH_ALAINSTANCETIMER6 = "/ilt";
	SlashCmdList["ALAINSTANCETIMER"] = function(msg)
		if strfind(msg, "^toggle") then
			if SET.enabled then
				__ns.DisableUI();
			else
				__ns.EnableUI();
			end
		elseif strfind(msg, "^enable") or strfind(msg, "^on") then
			__ns.EnableUI();
		elseif strfind(msg, "^disable") or strfind(msg, "^off") then
			__ns.DisableUI();
		elseif strfind(msg, "^toggle_lock") then
			if SET.locked then
				__ns.UnlockUI();
			else
				__ns.LockUI();
			end
		elseif strfind(msg, "^lock") then
			__ns.LockUI();
		elseif strfind(msg, "^unlock") then
			__ns.UnlockUI();
		elseif strfind(msg, "^reset_pos") then
			SET.pos = nil;
			__ns.ui:ClearAllPoints();
			__ns.ui:SetPoint(__ns.GetDefPos());
		end
	end
-->

